﻿namespace HeuristicLab.Algorithms.PushGP.Interpreter {
  using System;

  public class PooledPushGpInterpreter : PushGpInterpreter, IDisposable {

    private readonly PushGpInterpreterPool container;

    public PooledPushGpInterpreter(PushGpInterpreterPool container, Configuration config)
      : base(config) {
      this.container = container;
    }

    public void Dispose() {
      this.Reset();
      this.Configuration = this.Configuration;
      this.container.Free(this);
    }
  }
}
